/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.sanskritlibrary;

import java.io.BufferedWriter;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.sanskritlibrary.huet.Configuration;
import org.sanskritlibrary.huet.PadaStemRoot;
import org.sanskritlibrary.huet.ScreenScraper;
import org.sanskritlibrary.huet.Utils;
import org.sanskritlibrary.servlet.SanskritLibraryServlet;

/**
 *
 * @author ralph
 */
public class Experiment extends SanskritLibraryServlet {
   

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        if (request.getParameter("slp1Sentence") == null) {
            this.forward("experiment.jsp", request, response);
            return;
        }
            Utils.transcoderDirectory = getServletContext().getRealPath("transcoders");
            String sentence = request.getParameter("slp1Sentence");
            String sentenceNumber = request.getParameter("sentenceNumber");
            String linkNumber = request.getParameter("linkNumber");
            String path = getServletContext().getRealPath("config.xml");
            try {
                String programDirectory = getServletContext().getRealPath(".");
                programDirectory = programDirectory.substring(0, programDirectory.length()-2);
                Utils.templateDirectory = programDirectory;
                Configuration config = new Configuration(path, programDirectory);
                PadaStemRoot.targetEncoding = request.getParameter("displayEncoding");       // So that roman sent back by Gerard can be reformatted
                String numSolutionsString = request.getParameter("numSolutions");
                int numSolutions = 200;
                if (numSolutionsString != null) {
                    if (numSolutionsString.trim().length() != 0) {
                        numSolutions = Integer.parseInt(numSolutionsString);
                    }
                }
                ScreenScraper ss = new ScreenScraper(config, sentence,
                        Integer.parseInt(sentenceNumber), numSolutions, "SL", Integer.parseInt(linkNumber));      // TODO store encoding in web page
                ss.setInflectionFormat(request.getParameter("inflectionFormat"));
                ss.setDisplayEncoding(PadaStemRoot.targetEncoding);
                ss.setInputEncoding(request.getParameter("inputEncoding"));
                ss.doScreenScrape(null);
                sendHTML(response, ss.getHTML());
                String td = getTaggingDirectory(request);

                // Copy new version of solution to taggingDirectory
                String fn = String.format("%s/sentence%s.html", td, sentenceNumber);
                BufferedWriter bw = IOAssistance.openWriter(fn);
                bw.write(ss.getHTML());
                bw.close();

                // Copy new version of Huet's solution to the web directory.
                fn = String.format("%s/html/huet%s.html", programDirectory, sentenceNumber);
                bw = IOAssistance.openWriter(fn);
                bw.write(ss.getHuet());
                bw.close();

                // Copy new version of Huet's solution page to the taggingDirectory so Peter will get it
                fn = String.format("%s/huet%s.html", td, sentenceNumber);
                bw = IOAssistance.openWriter(fn);
                bw.write(ss.getHuet());
                bw.close();

//                // Now delete any saved tagging information for the sentence
                File file = new File(String.format("%s/sentence%s.xml", getTaggingDirectory(request), sentenceNumber));
                if (file.exists()) {
                    file.delete();
                }
            } catch (Exception ex) {
                sendHTML(response,
                        String.format("<html><head><title>Error</title></head><body><p>%s</p></body></html>", ex.getMessage()));
            }

    } 

    private void sendHTML(HttpServletResponse response, String html) throws IOException {
        response.setContentType("text/html; charset=UTF-8");
        PrintWriter pw = response.getWriter();
        pw.write(html);
    }

    private String getTaggingDirectory(HttpServletRequest request) {
            String dir = (String)this.getServletContext().getInitParameter("taggingDirectory");
            String contextPath = request.getContextPath().substring(1);
            File fdir = new File(String.format("%s/%s", dir, contextPath));
            if (!fdir.exists()) {
                fdir.mkdirs();
            }
            return fdir.getAbsolutePath();
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
