package org.sanskritlibrary;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.net.URL;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.sanskritlibrary.huet.Configuration;
import org.sanskritlibrary.huet.PadaStemRoot;
import org.sanskritlibrary.huet.ScreenScraper;
import org.sanskritlibrary.huet.Utils;
import org.sanskritlibrary.huet.Constants;
import org.sanskritlibrary.servlet.SanskritLibraryServlet;

public class SaveTagging extends SanskritLibraryServlet {
   
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
/*
        try {
        String path = getServletContext().getRealPath("config.xml");
        Configuration config = new Configuration(path);
        String url = getServletContext().getInitParameter("SHcgi");
        String sentence = this.getCookieValue(request, "sentence");
        if (sentence == null) {
            sentence = "0";
        }
        int n = Integer.parseInt(sentence);
        request.setAttribute("result", Integer.toString(n));

        Cookie c = new Cookie("sentence", Integer.toString(++n));
        response.addCookie(c);

        this.forward("Fixup.jsp", request, response);
        } catch (Exception ex) {
            throw new ServletException(ex.getMessage());
        }
*/
        String command = request.getParameter("command");
        if (command == null) {
            try {
                String htmlDirectory = getServletContext().getRealPath("html");
                String index = IOAssistance.readEntireFile(String.format("%s/index.html", htmlDirectory));
                sendHTML(response, index);
            } catch (Exception ex) {
                sendMessage(response, ex.getMessage());
            }
        } else if (command.equals("transcode")) {
            String source = request.getParameter("source");
            String target = request.getParameter("target");
            String text = request.getParameter("text");
            Utils.transcoderDirectory = getServletContext().getRealPath("transcoders");
            String transcode = Utils.convertWithPassThrough(text, source, target);
            sendUTF8(response, transcode);
        } else if (command.equals("loadSolution")) {
            try {
                String htmlDirectory = getServletContext().getRealPath("html");
                String sentenceNumber = request.getParameter("sentenceNumber");
                String td = getTaggingDirectory(request);
                String fn = String.format("%s/sentence%s.html", td, sentenceNumber);
                if (new File(fn).exists() == false) {
                    fn = String.format("%s/sentence%s.html", htmlDirectory, sentenceNumber);
                }
                String solution = IOAssistance.readEntireFile(fn);
                loadIndexSupp(request);         // be sure that indexSupp.txt is in taggingDirectory
                loadHuet(request);              // move Huet solution to web directory if it has changed.
                sendHTML(response, solution);
            } catch (Exception ex) {
                sendMessage(response, ex.getMessage());
            }
        } else if (command.equals("getTagging")) {
            String sentenceNumber = request.getParameter("sentenceNumber");
            File file = new File(String.format("%s/sentence%s.xml", getTaggingDirectory(request), sentenceNumber));
            if (file.exists()) {
                try {
                    String xml = IOAssistance.readEntireFile(file.getAbsolutePath());
                    sendMessage(response, xml);
                } catch (Exception ex) {
                    sendMessage(response, String.format("!%s", ex.getMessage()));
                }
            } else {
                sendMessage(response, "");
            }
        } else if (command.equals("resend")) {
            Utils.transcoderDirectory = getServletContext().getRealPath("transcoders");
            String cpts = request.getParameter("cpts");
            String sentence = request.getParameter("slp1Sentence");
            String sentenceNumber = request.getParameter("sentenceNumber");
            String linkNumber = request.getParameter("linkNumber");
            String path = getServletContext().getRealPath("config.xml");
            try {
                String programDirectory = getServletContext().getRealPath(".");
                programDirectory = programDirectory.substring(0, programDirectory.length()-2);
                Utils.templateDirectory = programDirectory;
                Configuration config = new Configuration(path, programDirectory);
                PadaStemRoot.targetEncoding = request.getParameter("displayEncoding");       // So that roman sent back by Gerard can be reformatted
                String numSolutionsString = request.getParameter("numSolutions");
                int numSolutions = 200;
                if (numSolutionsString != null) {
                    numSolutions = Integer.parseInt(numSolutionsString);
                }
                ScreenScraper ss = new ScreenScraper(config, sentence, 
                        Integer.parseInt(sentenceNumber), numSolutions, "SL", Integer.parseInt(linkNumber));      // TODO store encoding in web page
                ss.setInflectionFormat(request.getParameter("inflectionFormat"));
                ss.setDisplayEncoding(PadaStemRoot.targetEncoding);
                ss.setInputEncoding(request.getParameter("inputEncoding"));
                ss.setCpts(cpts);
                Constants.OS = request.getParameter("OS");
                ss.doScreenScrape(null);
                sendHTML(response, ss.getHTML());
                String td = getTaggingDirectory(request);

                // Copy new version of solution to taggingDirectory
                String fn = String.format("%s/sentence%s.html", td, sentenceNumber);
                BufferedWriter bw = IOAssistance.openWriter(fn);
                bw.write(ss.getHTML());
                bw.close();

                // Copy new version of Huet's solution to the web directory.
                fn = String.format("%s/html/huet%s.html", programDirectory, sentenceNumber);
                bw = IOAssistance.openWriter(fn);
                bw.write(ss.getHuet());
                bw.close();

                // Copy new version of Huet's solution page to the taggingDirectory so Peter will get it
                fn = String.format("%s/huet%s.html", td, sentenceNumber);
                bw = IOAssistance.openWriter(fn);
                bw.write(ss.getHuet());
                bw.close();

//                // Now delete any saved tagging information for the sentence
                File file = new File(String.format("%s/sentence%s.xml", getTaggingDirectory(request), sentenceNumber));
                if (file.exists()) {
                    file.delete();
                }
            } catch (Exception ex) {
                sendHTML(response,
                        String.format("<html><head><title>Error</title></head><body><p>%s</p></body></html>", ex.getMessage()));
            }
        } else if (command.equals("getIndexSupp")) {
            String indexSupp = getIndexSupp(request);
            sendMessage(response, indexSupp);
        } else if (command.equals("sktgraph")) {
            byte[] b = getSummaryPage("http://localhost/cgi-bin/SKT/sktgraph?lex=MW&cache=t&st=t&us=f&cp=t&text=tam+ekASvena+mfgam+anusarantaM+mfgo+dUram+apAharat&t=SL&topic=&mode=g&corpus=Annotator&sentenceNumber=1001");
            sendHTML(response, new String(b, "UTF-8"));
        }
    }

    private byte[] getSummaryPage(String url) throws IOException {
        byte[] b = null;
        ArrayList<Byte> buffer = new ArrayList<Byte>();
//        String query = String.format("%s?q=%d", url, (int) (1000000 * Math.random()));
        String query = url;
        InputStream is = new URL(query).openStream();
        int ch = 0;
        while ((ch = is.read()) != -1) {
            buffer.add((byte) ch);
        }
        b = new byte[buffer.size()];
        int i = 0;
        for (Byte bb : buffer) {
            b[i++] = bb;
        }
        return b;
    }



    // If original huet solution has been changed then copy it from tagging directory to web directory
    private void loadHuet(HttpServletRequest request) throws IOException {
        String sentenceNumber = request.getParameter("sentenceNumber");
        File fnhuet2 = new File(String.format("%s/huet%s.html", getTaggingDirectory(request), sentenceNumber));
        if (fnhuet2.exists()) {      // was original sentence editted? If so, replace original page with new one
            BufferedReader br = IOAssistance.openReader(fnhuet2.getAbsolutePath());
            String fnhuet1 = String.format("%s/huet%s.html", getServletContext().getRealPath("html"), sentenceNumber);
            BufferedWriter bw = IOAssistance.openWriter(fnhuet1);
            String line;
            while ((line = br.readLine()) != null) {
                bw.write(line);
                bw.write("\n");
            }
            br.close();
            bw.close();
        }

    }


    @Override
    // Called when user clicks the Save button
    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        try {
            String result = request.getParameter("result");
            String sentenceNumber = request.getParameter("sentenceNumber");
            String status = request.getParameter("status");
            String linkNumber = request.getParameter("linkNumber");

            String path = String.format("%s/sentence%s.xml", getTaggingDirectory(request), sentenceNumber);
            BufferedWriter bw = IOAssistance.openWriter(path);
            bw.write(result);
            bw.close();

            String indexSupp = getIndexSupp(request);
            if (indexSupp != null && linkNumber != null && status != null) {
                String s = "?";
                if (status.equals("done")) {
                    s = "d";
                } else if (status.equals("inprogress")) {
                    s = "p";
                }
                StringBuilder sb = new StringBuilder(indexSupp);
                int offset = Integer.parseInt(linkNumber);
                sb.replace(offset, offset+1, s);
                saveIndexSupp(request, sb.toString());
            }
            sendMessage(response, String.format("OK. Saved in %s", path));
        } catch (Exception ex) {
            sendMessage(response, ex.getMessage());
        }
    }

    private String getIndexSupp (HttpServletRequest request) {
        try {
            //String fn = getServletContext().getRealPath("html/indexSupp.txt");
            loadIndexSupp(request);
            String fn = String.format("%s/indexSupp.txt", getTaggingDirectory(request));
            return IOAssistance.readEntireFile(fn);
        } catch (Exception ex) {
            System.out.format("In getIndexSupp: %s\n", ex.getMessage());
            return null;
        }
    }

    private void saveIndexSupp (HttpServletRequest request, String indexSupp) throws IOException {
        //String fn = getServletContext().getRealPath("html/indexSupp.txt");
        String fn = String.format("%s/indexSupp.txt", getTaggingDirectory(request));
        BufferedWriter bw = IOAssistance.openWriter(fn);
        bw.write(indexSupp);
        bw.close();
    }

    private void loadIndexSupp (HttpServletRequest request) throws IOException {
        File f = new File(String.format("%s/indexSupp.txt", getTaggingDirectory(request)));
        if (!f.exists()) {
            String fn = getServletContext().getRealPath("html/indexSupp.txt");
            try {
                String indexSupp = IOAssistance.readEntireFile(fn);
                saveIndexSupp(request, indexSupp);
            } catch (Exception ex) {
                throw new IOException(ex.getMessage());
            }
        }
    }


    private String getTaggingDirectory(HttpServletRequest request) {
            String dir = (String)this.getServletContext().getInitParameter("taggingDirectory");
            String contextPath = request.getContextPath().substring(1);
            File fdir = new File(String.format("%s/%s", dir, contextPath));
            if (!fdir.exists()) {
                fdir.mkdirs();
            }
            return fdir.getAbsolutePath();
    }

    private void sendHTML(HttpServletResponse response, String html) throws IOException {
        response.setContentType("text/html; charset=UTF-8");
        PrintWriter pw = response.getWriter();
        pw.write(html);
    }

    private void sendMessage(HttpServletResponse response, String msg) throws IOException {
        response.setContentType("text/xml; charset=UTF-8");
        PrintWriter pw = response.getWriter();
        pw.write(msg);
    }

    private void sendUTF8 (HttpServletResponse response, String msg) throws IOException {
        response.setContentType("text/text; charset=UTF-8");
        PrintWriter pw = response.getWriter();
        pw.write(msg);
    }

    @Override
    public String getServletInfo() {
        return "Short description";
    }
    
}
